; Universaltreiber zum gleichzeitigen Betreiben
; von SR-LCD-Interface, PCF-LCD-Interface und PCF8574
; Portexpandern an einer Unit
;
; Einsprungadressen:
; SR-LCD:(in Klammer zum Vgl. die Addr. bei srlcd.asm)
;   send  &h101 (&h101)
;   Low   &h124 (&h12e)
; PCF8574 Portexpander:
;   write &h167
;   read  &h174
; PCF-LCD:(in Klammer zum Vgl. die Addr. bei pcflcd.asm)
;   char  &h18a (&h101)
;   cmd   &h193 (&h10b)
;   cmd8  &h19c (&h115)
;   setL  &h1ab (&h11f)
; LCD-Ausgaben mittels print
;   Print &h14f


ReadEEByte equ $0e04
; Bereich fr SR-LCD
port    equ $02 ; Port C
DIR     equ $06 ;PortCdir
dtas    equ 1   ;Port 10
shclk   equ 0   ;Port  9
stclk   equ 3   ;Port 12


        org $101
send    lda $92
        jsr Put8Bit
        lda $94 
        jsr Put8Bit
        jsr Store
        jsr LOW
        rts
        
Put8Bit ldx #8
NextBit rola
        bcc LoBit
        bset dtas,port
        bra PutClk
LoBit   bclr dtas,port
PutClk  jsr Clock
        decx
        bne NextBit
        rts        
        
LOW     bclr shclk,port ;ersten 10-SR(LCD)-Ports auf Low
        bclr stclk,port ;letzten 6-SR(out)-Ports nach $92 setzen bit(2-7)
        lda $92
        ldx #6
NB      rola
        bcc LB
        bset dtas,port
        bra PC
LB      bclr dtas,port
PC      jsr Clock
        decx
        bne NB        
        bclr dtas,port
        ldx #10
Nextclk jsr Clock 
        decx
        bne Nextclk
Store   bset stclk,port ;Send Store Clock
        bclr stclk,port
        rts

Clock   bset shclk,port ;Send Shift Clock
        bclr shclk,port
        rts

; Textausgaben mittels print fr PCF und SRLCD
; fr PCFLCD: sys prnLCD, LCD_Light, -1, PCFaddr
; fr SRLCD:  sys prnLCD, 0, LCD_RS_1 or SRPorts

print
	jsr ReadEEByte
	bra getchar
printchar
        lda $93
        bne pcfprint
        jsr send
	bra getchar
pcfprint
        jsr char
getchar
	jsr ReadEEByte
	sta $94
	bne printchar
	rts        

; Bereich fr PCF-LCD & Portexpander
        
i2c_start equ $083C
i2c_write equ $0846
i2c_read  equ $086F
i2c_readlast equ $08BB
i2c_stop  equ $08E5


; PCF8574 setzen
setpcf  jsr conpcf
        ldx $94
        jsr i2c_write
        jsr i2c_stop
        bra coneeprom

; PCF8574 lesen
getpcf  jsr conpcf
        jsr i2c_read
        sta $92
        jsr i2c_readlast
        bra coneeprom
        
conpcf  jsr i2c_readlast
        ldx $92
        jsr i2c_start
        rts


; Zeichen auf das PCF-LCD ausgeben
char    jsr get96
        ora #$05
        sta $96
        bra write4bit

; Kommando-Byte an das PCF-LCD senden
cmd     jsr get96
        ora #$04
        sta $96
        bra write4bit

; Kommando-Byte an das PCF-LCD senden 8Bit (fr Init)
cmd8    jsr get96
        ora #$04
        sta $96
        jsr write
        jsr i2c_stop
        bra coneeprom

setL    jsr conpcf
;        jsr i2c_readlast
;        ldx $92
;        jsr i2c_start
        lda $96
        and #$08
        ora $94
        tax
        jsr i2c_write
        jsr i2c_stop
        bra coneeprom

get96   jsr i2c_readlast
        lda $96
        and #$08
        rts
        
write   ldx $92
        jsr i2c_start
        lda $94

writenibble
        and #$F0
        ora $96 ;register fr LCD-Beleuchtung, RS, R/W
        tax
        and #$FB
        sta $93
        jsr i2c_write
        ldx $93
        jsr i2c_write
        rts

write4bit
        jsr write
        lda $94
        asla
        asla
        asla
        asla
        jsr writenibble
        jsr i2c_stop
        
coneeprom 
        ldx #$0A0
        jsr i2c_start
        ldx $066
        jsr i2c_write
        ldx $067
        jsr i2c_write
        ldx #$0A1
        jsr i2c_start
        rts


        
                