'-----------------------------------------------------
'Ansteuereungsbeispiel fr Multitreiber
' SRLCD + PCFLCD + PCF8574-Portexpander
'CCTools 2002 cctools.hs-control.de (10.08.2002)
'-----------------------------------------------------
define ds port[10]    ' Ports
define shclk port[9]  ' fr
define stclk port[12] ' SRLCD (nicht ndern !)
define pop DA[1]' Trick zum auslesen des Stacks(siehe ccintern.dharlos.de)

'Die Variablen knnen frei zugewiesen werden
'und mssen nicht den selben Index haben
define cmd byte[1]
define PCFLCDLight Bit[184]

define SRPorts byte[24]
define RS Bit[185]
define SRLCDLight Bit[187]
define SRPort1 Bit[188]
define SRPort2 Bit[189]
define SRPort3 Bit[190]
define SRPort4 Bit[191]
define SRPort5 Bit[192]

define PCF 64 ' Adresse der PCF-Bausteins fr PCFLCD
' Konstanten fr SRLCD:
define LCD_RS_0 &B10 : define LCD_RS_1 &B11 :define LCD_nowrite &B0
' Einsprungadressen:
define SRSend &h101   'fr SRLCD
define SRLow &h124    'fr SRLCD
define PCFchar &h18a  'fr PCFLCD
define PCFcmd &h193   'fr PCFLCD
define PCFcmd8 &h19c  'fr PCFLCD
define PCFsetL &h1ab  'fr PCFLCD
define prnLCD &h14f   'fr print-Ausgaben am LCD
define PCFwrite &h167 'fr PCF8574-Portexpander
define PCFread &h174  'fr PCF8574-Portexpander

'ASCII-Tabelle
Define A_ &H41 : Define B_ &H42 : Define C_ &H43 : Define D_ &H44 : Define E_ &H45
Define F_ &H46 : Define G_ &H47 : Define H_ &H48 : Define I_ &H49 : Define J_ &H4A
Define K_ &H4B : Define L_ &H4C : Define M_ &H4D : Define N_ &H4E : Define O_ &H4F
Define P_ &H50 : Define Q_ &H51 : Define R_ &H52 : Define S_ &H53 : Define T_ &H54
Define U_ &H55 : Define V_ &H56 : Define W_ &H57 : Define X_ &H58 : Define Y_ &H59 : Define Z_ &H5A
Define ak &H61 : Define bk &H62 : Define ck &H63 : Define dk &H64 : Define ek &H65
Define fk &H66 : Define gk &H67 : Define hk &H68 : Define ik &H69 : Define jk &H6A
Define kk &H6B : Define lk &H6C : Define mk &H6D : Define nk &H6E : Define ok &H6F
Define pk &H70 : Define qk &H71 : Define rk &H72 : Define sk &H73 : Define tk &H74
Define uk &H75 : Define vk &H76 : Define wk &H77 : Define xk &H78 : Define yk &H79 : Define zk &H7A
Define SPACE &H20 : Define MINUS &H2D : Define GLEICH &H3D : Define DPP &H3A
Define Dot &H2E
Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H94 : Define Line4 &HD4 'Fr 4x20 LCD
'Define Line1 &H80 : Define Line2 &HC0 : Define Line3 &H90 : Define Line4 &HD0 'Fr 4x16 LCD


'SRLCD initialisieren:
gosub SRLCD_Init
'PCFLCD initialisieren:
gosub PCFLCD_Init

'Text ausgeben SRLCD:
sys prnLCD,0,SRPorts : print "Hello World";
'Text ausgeben PCFLCD:
sys prnLCD,PCFLCDLight,-1,PCF : print "PCF-LCD";

'Zeichen ausgeben SRLCD:
cmd= X_ : gosub SRLCD_Char
'Zeichen ausgeben PCFLCD:
cmd= X_ : gosub PCFLCD_Char

'Zeile setzen SRLCD:
cmd=Line2 : gosub SRLCD_CMD
'Zeile setzen PCFLCD:
cmd=Line2 : gosub PCFLCD_CMD

'Display lschen SRLCD:
gosub SRLCD_CLS
'Display lschen PCFLCD:
gosub PCFLCD_CLS

'Kommando senden SRLCD
'cmd=COMMAND : gosub SRLCD_CMD
'Kommando senden
'cmd=COMMAND : gosub PCFLCD_CMD

'Ports am SRLCD setzen:
SRPort1 = On : gosub setSRPorts

'LCD-Beleuchtung schalten SRLCD:
SRLCDLight = On : gosub setSRPorts
'LCD-Beleuchtung schalten PCFLCD:
PCFLCDLight = Off : gosub setPCFLight
'oder
sys PCFsetL, Off ,0,PCF

'PCF8574 Portexpander auslesen:
sys PCFread, PCF
WERT = pop
'PCF8574 Portexpander schreiben:
sys PCFwrite, WERT,PCF




'----LCD-Funktionen--SRLCD-------------------
'Zahlausgaben
#SR_LCD_Zahl3 ' 3 stellige Zahl ausgeben
if cmd > 99 then sys SRsend,(cmd/100)+&h30,LCD_RS_1 or SRPorts else sys SRsend,&h20,LCD_RS_1 or SRPorts
#SR_LCD_Zahl2 ' 2 stellige Zahl ausgeben
if cmd > 9 then sys SRsend,((cmd/10) mod 10)+&h30,LCD_RS_1 or SRPorts else sys SRsend,&h20,LCD_RS_1 or SRPorts
#SR_LCD_Zahl1 ' 1 stellige Zahl ausgeben
sys SRsend,(cmd mod 10)+&h30,LCD_RS_1 or SRPorts
return
#SR_LCD_Zahl3null ' 3 stellige Zahl ausgeben mit fhrender Nullen z.B.: 025 od. 005
sys SRsend,(cmd/100)+&h30,LCD_RS_1 or SRPorts
#SR_LCD_Zahl2null ' 2 stellige Zahl ausgeben mit fhrender Null z.B.: 05
sys SRsend,((cmd/10) mod 10)+&h30,LCD_RS_1 or SRPorts
goto LCD_Zahl1

#SRLCD_CMD
sys SRsend,cmd,LCD_RS_0 or SRPorts
return
#SRLCD_Char
sys SRsend,cmd,LCD_RS_1 or SRPorts
return
#SRLCD_CLS
sys SRsend,&b00000001,LCD_RS_0 or SRPorts
return
#SRLCD_Init
ds=off
shclk=off
stclk=off
sys SRlow,0
sys SRsend,&b00111000,LCD_RS_0
sys SRsend,&b00001111,LCD_RS_0
sys SRsend,&b00000001,LCD_RS_0
sys SRsend,&b00001110,LCD_RS_0
return
#setSRports 'Portzustnde an SR-LCD aktualisieren
sys SRlow,SRPorts
return

'----LCD-Funktionen--PCFLCD------------------
'Zahlausgaben
#LCD_Zahl3 ' 3 stellige Zahl ausgeben
if cmd > 99 then sys PCFchar,LCDLight,(cmd/100)+&h30,PCF else sys PCFchar,LCDLight,&h20,PCF
#LCD_Zahl2 ' 2 stellige Zahl ausgeben
if cmd > 9 then sys PCFchar,LCDLight,((cmd/10) mod 10)+&h30,PCF else sys PCFchar,LCDLight,&h20,PCF
#LCD_Zahl1 '1 stellige Zahl ausgeben
sys PCFchar,LCDLight,(cmd mod 10)+&h30,PCF
return
#LCD_Zahl3null ' 3 stellige Zahl ausgeben mit fhrender Nullen z.B.: 025 od. 005
sys PCFchar,LCDLight,(cmd/100)+&h30,PCF
#LCD_Zahl2null ' 2 stellige Zahl ausgeben mit fhrender Null z.B.: 05
sys PCFchar,LCDLight,((cmd/10) mod 10)+&h30,PCF
goto LCD_Zahl1

#PCFLCD_CLS
sys PCFcmd,PCFLCDLight,&b00000001,PCF
return
#PCFLCD_CMD
sys PCFcmd,PCFLCDLight,cmd,PCF
return
#PCFLCD_Char
sys PCFchar,PCFLCDLight,cmd,PCF
return
#PCFLCD_Init
sys PCFsetL,0,0,PCF
sys PCFcmd,0,&b00111000,PCF
sys PCFcmd8,0,&b00100000,PCF
sys PCFcmd,0,&b00101000,PCF
sys PCFcmd,0,&b00001110,PCF
sys PCFcmd,0,&b00000001,PCF
sys PCFcmd,0,&b00000110,PCF
return
#setPCFLight
sys PCFsetL,PCFLCDLight,0,PCF
return

//syscode "srpcf3_1.s19" 'nur einmal laden, dann auskommentieren !


